install 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. OS=$(uname -s)
  13. if [ $OS = "Linux" ]; then
  14. OS="GNU/Linux"
  15. if [ -f /etc/os-release ]; then
  16. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  17. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  18. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. for i in $ID_LIKE; do
  20. #printf "$i\n"
  21. case $i in
  22. debian|ubuntu)
  23. debianOS=true
  24. break
  25. ;;
  26. rhel|fedora)
  27. rhelOS=true
  28. break
  29. ;;
  30. *)
  31. debianOS=false
  32. rhelOS=false
  33. ;;
  34. esac
  35. done
  36. elif [ -f /etc/debian-version ]; then
  37. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  38. DIST="Debian"
  39. REV=""
  40. ID_LIKE="debian"
  41. debianOS=true
  42. elif [ -f /etc/redhat-release ]; then
  43. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  44. DIST="Red-Hat"
  45. REV=""
  46. ID_LIKE="rhel"
  47. rhelOS=true
  48. else
  49. # Other Linux (No Soportado)
  50. DIST=""
  51. REV=""
  52. ID_LIKE=""
  53. fi
  54. else
  55. # UNIX, OS X, ... (No Soportado)
  56. DIST=$OS
  57. REV=""
  58. fi
  59. #printf " $OS $DIST $REV\n"
  60. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  61. }
  62. comprobarRoot() {
  63. if [ $(id -u) -ne 0 ]; then
  64. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  65. exit 1
  66. fi
  67. }
  68. comprobarDependencias() {
  69. # Comprobamos whiptail
  70. which whiptail > /dev/null 2>&1
  71. if [ $? -ne 0 ];then
  72. printf "ERROR:\t'whiptail' no disponible.\n"
  73. exit 1
  74. fi
  75. # Comprobamos hostnamectl
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. # Comprobamos apt-get
  83. which apt-get > /dev/null 2>&1
  84. if [ $? -ne 0 ]; then
  85. printf "ERROR:\t'apt-get' no está disponible.\n"
  86. exit 1
  87. fi
  88. # Actualizamos base de datos del repositorio
  89. printf "Actualizando repositorio APT..."
  90. result=$(apt-get -q -y update)
  91. if [ $? -ne 0 ]; then
  92. printf "\nERROR:\tImposible actualizar repositorio.\n"
  93. printf "Detalles:\n$result\n"
  94. exit 1
  95. fi
  96. printf " OK.\n"
  97. # Comprobamos Firewall (ufw)
  98. which ufw > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'ufw' no disponible.\n"
  101. exit 1
  102. fi
  103. fi
  104. if [ $rhelOS = true ]; then
  105. # Comprobamos yum
  106. which yum > /dev/null 2>&1
  107. if [ $? -ne 0 ]; then
  108. printf "ERROR:\t'yum' no está disponible.\n"
  109. exit 1
  110. fi
  111. # Actualizamos base de datos del repositorio
  112. printf "Actualizando repositorio YUM..."
  113. result=$(yum -y makecache 2>&1)
  114. if [ $? -ne 0 ]; then
  115. printf "\nERROR:\tImposible actualizar repositorio.\n"
  116. printf "Detalles:\n$result\n"
  117. exit 1
  118. fi
  119. printf " OK.\n"
  120. # Comprobamos Firewall (firewall-cmd)
  121. which firewall-cmd > /dev/null 2>&1
  122. if [ $? -ne 0 ]; then
  123. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  124. exit 1
  125. fi
  126. fi
  127. }
  128. inicializarVariables() {
  129. debianOS=false
  130. rhelOS=false
  131. apacheOn=false
  132. nginxOn=false
  133. mySQLOn=false
  134. mariaDBOn=false
  135. phpOn=false
  136. mediaWikiOn=false
  137. moodleOn=false
  138. actualizacionesOn=false
  139. }
  140. instalacionExpress() {
  141. apacheOn=true
  142. mariaDBOn=true
  143. phpOn=true
  144. mediaWikiOn=true
  145. moodleOn=true
  146. actualizacionesOn=true
  147. }
  148. mostrarBienvenida() {
  149. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  150. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
  151. exit 1
  152. fi
  153. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
  154. if [ $? -ne 0 ]; then
  155. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  156. exit 2
  157. fi
  158. }
  159. mostrarExpress() {
  160. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  161. "Express" "Instalación rápida" ON \
  162. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  163. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  164. if [ $? -ne 0 ]; then
  165. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  166. exit 2
  167. fi
  168. case $express in
  169. Express)
  170. instalacionExpress
  171. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  172. ;;
  173. Avanzada)
  174. mostrarAvanzada
  175. ;;
  176. *)
  177. printf "ERROR:\tError interno (selección express).\n"
  178. exit 1
  179. ;;
  180. esac
  181. }
  182. mostrarAvanzada() {
  183. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  184. "WebServer" "Instalar servidor web http/https" ON \
  185. "Database" "Instalar una base de datos SQL" ON \
  186. "PHP" "Instala PHP7" ON \
  187. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  188. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  189. "Moodle" "Instalar campus virtual con Moodle" ON \
  190. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  191. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  192. if [ $? -ne 0 ]; then
  193. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  194. exit 2
  195. fi
  196. # Mejora: autodetección de componentes ya instalados
  197. for i in $componentes; do
  198. case $i in
  199. \"WebServer\")
  200. mostrarWebServer
  201. ;;
  202. \"Database\")
  203. mostrarDatabase
  204. ;;
  205. \"PHP\")
  206. phpOn=true
  207. ;;
  208. \"SSL/TLS\")
  209. # 2 Opciones: Let's Encrypt o Autofirmado
  210. ;;
  211. \"MediaWiki\")
  212. mediaWikiOn=true
  213. ;;
  214. \"Moodle\")
  215. moodleOn=true
  216. ;;
  217. \"Actualizaciones\")
  218. actualizacionesOn=true
  219. ;;
  220. *)
  221. printf "ERROR:\tError interno (selección de componentes).\n"
  222. exit 1
  223. ;;
  224. esac
  225. done
  226. }
  227. mostrarWebServer() {
  228. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  229. "Apache" "Instalar el servidor web Apache2" ON \
  230. "Nginx" "Instalar el servidor web Nginx" OFF \
  231. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  232. if [ $? -ne 0 ]; then
  233. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  234. exit 2
  235. fi
  236. case $webServer in
  237. Apache)
  238. apacheOn=true
  239. ;;
  240. Nginx)
  241. nginxOn=true
  242. ;;
  243. *)
  244. printf "ERROR:\tError interno (selección de web server).\n"
  245. exit 1
  246. ;;
  247. esac
  248. # Otras opciones (FQDN)
  249. establecerFQDN
  250. }
  251. establecerFQDN() {
  252. while [ -z $hostname ]; do
  253. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  254. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  255. hostnamectl set-hostname $hostname
  256. else
  257. hostname=$(hostname)
  258. fi
  259. done
  260. #printf "\nHostname: $hostname\n"
  261. }
  262. instalarApache() {
  263. if [ $debianOS = true ];then
  264. result=$(apt-get -q -y install apache2 2>&1)
  265. if [ $? -ne 0 ]; then
  266. printf "\nERROR:\tError al instalar Apache2.\n"
  267. printf "Detalles:\n$result\n"
  268. exit 1
  269. fi
  270. elif [ $rhelOS = true ]; then
  271. result=$(yum -y install httpd 2>&1)
  272. if [ $? -ne 0 ]; then
  273. printf "\nERROR:\tError al instalar Apache2.\n"
  274. printf "Detalles:\n$result\n"
  275. exit 1
  276. fi
  277. else
  278. printf "\nERROR:\tError interno (instalación Apache2).\n"
  279. exit 1
  280. fi
  281. }
  282. instalarNginx() {
  283. if [ $debianOS = true ];then
  284. result=$(apt-get -q -y install nginx 2>&1)
  285. if [ $? -ne 0 ]; then
  286. printf "\nERROR:\tError al instalar Nginx.\n"
  287. printf "Detalles:\n$result\n"
  288. exit 1
  289. fi
  290. elif [ $rhelOS = true ]; then
  291. # Hay que instalar primero otro repositorio
  292. result=$(yum -y install epel-release)
  293. if [ $? -ne 0 ]; then
  294. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  295. printf "Detalles:\n$result\n"
  296. exit 1
  297. fi
  298. result=$(yum -y install nginx 2>&1)
  299. if [ $? -ne 0 ]; then
  300. printf "\nERROR:\tError al instalar Nginx.\n"
  301. printf "Detalles:\n$result\n"
  302. exit 1
  303. fi
  304. else
  305. printf "\nERROR:\tError interno (instalación Nginx).\n"
  306. exit 1
  307. fi
  308. }
  309. mostrarDatabase() {
  310. if [ $debianOS = true ]; then
  311. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  312. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  313. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  314. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  315. if [ $? -ne 0 ]; then
  316. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  317. exit 2
  318. fi
  319. case $database in
  320. MySQL)
  321. mySQLOn=true
  322. ;;
  323. MariaDB)
  324. mariaDBOn=true
  325. ;;
  326. *)
  327. printf "ERROR:\tError interno (selección de base de datos).\n"
  328. exit 1
  329. ;;
  330. esac
  331. elif [ $rhelOS = true ]; then
  332. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
  333. if [ $? -ne 0 ]; then
  334. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  335. exit 2
  336. fi
  337. mariaDBOn=true
  338. else
  339. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  340. exit 1
  341. fi
  342. # Otras opciones (contraseña)
  343. establecerSQLPasswd
  344. }
  345. establecerSQLPasswd() {
  346. control=false
  347. # Leemos la contreseña (stdin) y confirmamos
  348. while [ $control = false ]; do
  349. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  350. if [ $? -ne 0 ]; then
  351. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  352. exit 2
  353. fi
  354. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  355. if [ $? -ne 0 ];then
  356. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  357. exit 2
  358. fi
  359. if [ $sqlPasswd = $sqlPasswd2 ];then
  360. control=true
  361. fi
  362. done
  363. # Establecemos contraseña y segurizamos la BD
  364. unset control sqlPasswd2
  365. }
  366. instalarMySQL() {
  367. if [ $debianOS = true ];then
  368. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  369. if [ $? -ne 0 ]; then
  370. printf "\nERROR:\tError al instalar MySQL.\n"
  371. printf "Detalles:\n$result\n"
  372. exit 1
  373. fi
  374. elif [ $rhelOS = true ]; then
  375. # MySQL no disponible en RHEL. 2 opciones:
  376. # 1) Instalar un repositorio adicional
  377. # 2) No instalar MySQL en distribuciones RHEL
  378. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  379. exit 1
  380. else
  381. printf "\nERROR:\tError interno (instalación MySQL).\n"
  382. exit 1
  383. fi
  384. }
  385. instalarMariaDB() {
  386. if [ $debianOS = true ];then
  387. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  388. if [ $? -ne 0 ]; then
  389. printf "\nERROR:\tError al instalar MariaDB.\n"
  390. printf "Detalles:\n$result\n"
  391. exit 1
  392. fi
  393. elif [ $rhelOS = true ]; then
  394. result=$(yum -y install mariadb-server 2>&1)
  395. if [ $? -ne 0 ]; then
  396. printf "\nERROR:\tError al instalar MariaDB.\n"
  397. printf "Detalles:\n$result\n"
  398. exit 1
  399. fi
  400. else
  401. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  402. exit 1
  403. fi
  404. }
  405. # Comprobación del sistema e inicialización
  406. comprobarRoot
  407. inicializarVariables
  408. OSInfo
  409. comprobarDependencias
  410. # Bienvenida
  411. mostrarBienvenida
  412. # Selección de componentes (express vs avanzada)
  413. mostrarExpress
  414. # Pre-configuración
  415. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  416. # Instalación
  417. # FALTA: whiptail --gauge -> Más bonito
  418. # Servidor Web
  419. if [ $apacheOn = true ]; then
  420. printf "Instalando Web Server Apache..."
  421. instalarApache
  422. printf " OK.\n"
  423. elif [ $nginxOn = true ]; then
  424. printf "Instalando Web Server Nginx..."
  425. instalarNginx
  426. printf " OK.\n"
  427. fi
  428. # Base de Datos
  429. if [ $mySQLOn = true ]; then
  430. printf "Instalando Base de Datos MySQL..."
  431. instalarMySQL
  432. printf " OK.\n"
  433. elif [ $mariaDBOn = true ]; then
  434. printf "Instalando Base de Datos MariaDB..."
  435. instalarMariaDB
  436. printf " OK.\n"
  437. fi
  438. # PHP
  439. if [ $phpOn = true ]; then
  440. printf "Instalando PHP-7..."
  441. printf " OK.\n"
  442. fi
  443. # SSL/TLS
  444. # Falta por implementar
  445. # MediaWiki
  446. if [ $mediaWikiOn = true ]; then
  447. printf "Instalando MediaWiki..."
  448. printf " OK.\n"
  449. fi
  450. # Moodle
  451. if [ $moodleOn = true ]; then
  452. printf "Instalando Moodle..."
  453. printf " OK.\n"
  454. fi
  455. # Configuración
  456. # Configuración Apache
  457. # Virtual Hosts
  458. # Configuración Database
  459. # Configuración Segura
  460. # Configuración PHP
  461. # cgi.fix_pathinfo=0
  462. # Configurar máximo de subida de archivos
  463. # Configuración MediWiki
  464. # Configuración Moodle
  465. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  466. # Añadir reglas del cortafuegos
  467. # Configuración SSL/TLS
  468. # Generar certificados
  469. # Configurar certificados
  470. # Configurar actualizaciones
  471. if [ $actualizacionesOn = true ]; then
  472. printf "Configurando actualizaciones automáticas..."
  473. # CRONTAB
  474. printf " OK.\n"
  475. fi
  476. # Autodestrucción
  477. {
  478. for i in $(seq 0 5 50); do
  479. sleep 0.1
  480. echo $i
  481. done
  482. } | whiptail --gauge "Autodestrucción..." 7 70 0
  483. {
  484. for i in $(seq 50 5 100); do
  485. sleep 0.1
  486. echo $i
  487. done
  488. } | whiptail --gauge "Autopulverización..." 7 70 50